Subject: Re: [PATCH] sunrpc: use better NUMA affinities

From: "J. Bruce Fields" <[email-masked]>
Date: Mon, 1 Aug 2011 21:06:36 -0400

On Sat, Jul 30, 2011 at 09:30:25AM +1000, NeilBrown wrote:
> On Sat, 30 Jul 2011 06:34:44 +1000 Greg Banks <[email-masked]> wrote:
> > The "killall nfsd" semantics in those scripts are awful and lead to  
> > problems shutting down when there are lots of threads. It would  
> > probably be an improvement to provide a better shutdown mechanism and  
> > force distros to use it.
> 
> rpc.nfsd 0
> 
> will stop all nfsd threads.  Follow with
> 
>   exportfs -f
> 
> and you should be done.  I'm not 100% sure about the nfsv4 thread though -
> would need to check.
> 
> And yes - I would love it if distros could standardise on start/stop scripts
> so upstreams could maintain them sensibly.  This is my personal number 1
> reason for liking systemd - it pushes for this standardisation.

I can't remember if this is getting fixed in Fedora--probably not.  We
should fix it.

I'd also be fine with logging a deprecation message when someone signals
an nfsd thread.

> > Or, you could preserve the effective semantics by having a single  
> > "nfsd" thread whose purpose is to notice that it's being signalled and  
> > perform a clean shutdown (perhaps blocking the thread doing the kill()  
> > call until the shutdown has completed).
> 
> That's kinda neat.  It would be an ugly wart to have to keep around, but
> sometimes that the price we pay for "no regressions".

Yep; patch welcomed.

--b.
--
To unsubscribe from this list: send the line "unsubscribe linux-nfs" in
the body of a message to [email-masked]
More majordomo info at  http://vger.kernel.org/majordomo-info.html